//Created by Vadim647
//MiniSurvival - game of one evening (3 hours actualy)
//How2Play: W|A|S|D - movement, mouse to aim and shoot
//^ You control blue unit and need to defend from masses of corrupted red units.
//Point of game: Survive as long as you can.

#include <acknex.h>
#include <default.c>
//Standart includes
#define nv nullvector
//some shorter names
TEXT* npcModels = {string("creep2.mdl","creep1.mdl","creep3.mdl");}
//model names of corrupt units.
SOUND* npcDeath = "npcD.wav";
SOUND* laser1 = "laser1.wav";
SOUND* laser2 = "laser2.wav";
SOUND* laser3 = "laser4.wav";
//sounds in game.
VECTOR t_v;					//3 temp vectors
VECTOR vecFrom;				//
VECTOR vecTo;				//
var wave = 3;				//current wave
VECTOR creepv;				//[1] -> Max, [2] -> Current
STRING* t_s="#120";			//temp string
function mouse2level() {	//trace to get 3d mouse position.
vec_set(vecFrom.x,vector(mouse_cursor.x,mouse_cursor.y,10));
vec_set(vecTo,vecFrom);
vec_for_screen(vecFrom,camera);
vecTo.z = 5000;
vec_for_screen(vecTo,camera);
return(c_trace(vecFrom,vecTo,IGNORE_MODELS|IGNORE_PASSABLE|USE_POLYGON));}
function mcreep()			//corrupt unit action
{
	creepv.y += 1;	//increase ingame creep count
	set(my,SHADOW);	//shadow cast
	vec_set(my.skill1,vector(10 + wave * 10,7 + wave * 3,3 * (random(0.5)+0.75)));
	//alternative use for setting skill# 's
	while (my.skill1 > 0)
	{	//while it's alive
		vec_set(t_v,vector(player.x-my.x,player.y-my.y,0));//rotate towards player
		vec_to_angle(my.pan,t_v);
		if (player.skill1 > 0)
		{
			if (vec_dist(my.x,player.x)<32) //if it's near player
			{
				player.skill1 -= time_step * my.skill2 / 32;//start killing -> damage player
			}
			else
			{	//if it's far, move towards player without using any slow functions
				vec_add(my.x,vector(my.skill3*time_step*cosv(my.pan),my.skill3*time_step*sinv(my.pan),0));
			}
		}
		wait(1);
	}
	creepv.y -= 1;			//it was killed, so reduce creep count
	snd_play(npcDeath,25,0);//play death sound
	ent_remove(me);			//no epic death animations
}
function str_cat3(STRING* str1,var1,STRING* str2,var2,STRING* str3,var3)
{	//optimized function. eash use saves 2 semis
	str_cat_num(t_s,str1,var1);
	str_cat_num(t_s,str2,var2);
	str_cat_num(t_s,str3,var3);
}
function mplayer()	//player action
{
	player = me;	//set it as player
	set(my,SHADOW);	//shadow cast
	vec_set(my.skill1,vector(100,100,25));	//set variables
	vec_set(my.skill4,vector(8,5,3));		//method saves me 4 semi's
	while (my.skill1 > 0)
	{
		camera.pan = cycle(camera.pan + (key_e - key_q) * 4 * time_step,-180,180);
		vec_set(t_v,vector((cosv(camera.pan)*(key_w-key_s)+cosv(camera.pan+90)*(key_a-key_d)),
		(sinv(camera.pan)*(key_w-key_s)+sinv(camera.pan+90)*(key_a-key_d)),0));
		vec_normalize(t_v,time_step*my.skill4);	//something like movement.
		vec_add(my.x,t_v);						//instead of rotating it, you can make it there.
		//
		my.skill8 = clamp(my.skill8 - time_step,0,647);	//skill-up allowed time
		if (my.skill8 <= 0 && key_r && my.skill6>0) {my.skill2 += 35;my.skill4 += 0.2;}	//skills up ^
		if (my.skill8 <= 0 && key_t && my.skill6>0) {my.skill3 += 5;}
		if (my.skill8 <= 0 && key_y && my.skill6>0) {my.skill5 = maxv(my.skill5-0.2,1);}
		if (my.skill8 <= 0 && (key_r||key_t||key_y) && my.skill6>0) {my.skill6 -= 1;my.skill8 = 8;}
		//
		my.skill1 = clamp(my.skill1 + time_step * 0.10,-999,my.skill2);	//HP regeneration
		if (vec_dist(my.x,vector(0,0,my.z))>900) {my.skill1 -= time_step;}
		my.skill7 = clamp(my.skill7 - time_step,0,999);					//cooldown
		if (my.skill7 <= 0 && mouse_left)	//if cooldown below zero and mouse button pressed
		{
			creepv.z = integer(1+random(2.9));	//here it used as temp variable
			if (creepv.z == 1 && my.skill5 > 3.2) snd_play(laser1,35,0);//play 3 different random laser sounds
			if (creepv.z == 2 && my.skill5 > 3.2) snd_play(laser2,35,0);//^
			if (creepv.z == 3 && my.skill5 > 3.2) snd_play(laser3,35,0);//^
			my.skill7 = my.skill5;
			vec_set(vecTo,vector(my.x + 640 * cosv(my.pan),my.y + 640 * sinv(my.pan),0));//set it forward
			c_trace(my.x,vecTo,IGNORE_PASSABLE|IGNORE_ME);//first, trace there
			if (trace_hit==0) {vec_set(target,vecTo);}	//if nothing hit, set target to original.
			draw_line3d(my.x,NULL,100);				//draw a line there
			draw_line3d(my.x,vector(0,255,0),100);	//^
			draw_line3d(target,vector(0,255,0),100);//^
			if (you!=NULL) {you.skill1 -= my.skill3 * (0.75 + random(0.5));}//if someone's there, he got problems
		}
		//
		vec_set(camera.x,vector(-512,0,0));	//set camera position
		vec_rotate(camera.x,camera.pan);	//simple offset,
		vec_add(camera.x,my.x);			//but I dunno how to optimize it
		mouse2level();					//trace level
		vec_sub(target,my.x);			//and rotate ent towards mouse
		vec_to_angle(my.pan,vector(target.x,target.y,0));
		//
		str_cpy(t_s,"MiniSurvival by Vadim647\n");				//Show some stats.
		str_cat3("\nPlayer stats:\nHP: %.0f",my.skill1,"/%.0f",my.skill2,"\nDmg: %.0f",my.skill3);
		str_cat3("\nCooldown: %.1f",my.skill5,"\nSpeed: %.1f",my.skill4,"\nStat points: %.0f",my.skill6);
		str_cat3("\n\nCreep stats:\nHP: %.0f",10+wave*10,"\nDmg: %.0f",7+wave*3,"\nAlive: %.0f",creepv.y);
		draw_text(t_s,4,4,vector(96,192,96));	//draw stats.
		wait(1);
	}
	while (my.z > -2) {my.z -= time_step*2;wait(1);}//fall after death
}
function spawny()
{
	while (1)
	{
		vec_set(creepv,nv);
		while (creepv.x < wave * 8) //spawn units with interval at circle area.
		{
			creepv.x += 1;
			result = random(360);
			ent_create((npcModels.pstring)[integer(random(npcModels.strings))],vector(960*cosv(result),960*sinv(result),20),mcreep);
			wait(-2/wave-0.5);
		}
		while (creepv.y > 0) {wait(1);}
		player.skill6 += 1;
		wave++;
	}
}
BMAP* curmap="cursor.tga";
function main()
{
	vec_set(sky_color,vector(1,1,1));		//set sky color.
	video_switch(8,0,1);					//set fullscreen 1024x768
	shadow_stencil = 2;						//Stencil shadows
	level_load("flat.hmp");					//Load terrain
	mouse_map = curmap;						//mouse map.
	mouse_mode = 4;							//mouse mode.
	wait(3);								//wait 3 frames.
	vec_set(camera.pan,vector(120,-50,0));	//rotate camera.
	draw_textmode("Arial",3,18,90);			//set font & size.
	ent_create("creep0.mdl",vector(0,0,20),mplayer);	//
	spawny();								//function to spawn units.
	while (1)	//loop
	{	
		if (player.skill1 > 0)	//if player alive, display keys.
		{str_cpy(t_s,"Stats points keys:
		[R] Inc. HP by 35, Inc. Speed by 0.2
		[T] Inc. Dmg by 5
		[Y] Dec. Cooldown by 0.2\n");}
		else	//if died, display some info.
		{str_cpy(t_s,"Thank you for playing. Compare results for interest:
		Wave 1-10 : Can't get idea?
		Wave 11-17 : Just good for 100-semi's game
		Wave 18-? : You was so bored, or expected end of game & 'You Win' banner?
		Play again later, or send it to friends :)");}
		str_cat_num(t_s,"\nWave: %.0f\n",wave);
		draw_text(t_s,4,650,vector(96,224,96));
		wait(1);
	}
}